<'
package sbt;

import sbt_packet;
import sbt_header;
import sbt_types_and_defines;

extend sbt_packet_s {
   
   //constrain the default values for the 
   //start and end flags.  These values are 
   //soft constraints and can be overwritten 
   //by the user testcases
   keep soft start_flag == 0xFF;
   keep soft end_flag == 0xFF;
   
}; // extend sbt_...


extend sbt_reset_agent_u {
   keep soft number_of_clocks in range [40..50];
}; // extend sbt_rese...

extend sbt_header_s {
   
   //There may potentially be different types of headers
   //for SBT frames (user specific types).  Here, we 
   //constrain the header to be of the HDLC variety
   //keep soft kind == SBT_HEADER;
   
}; // extend sbt_...

'>
