This is the first visual inspection test of the environment
This is a really long line to get the style checker in eanalyzer to complain about too many characters on one line
<'
import sbt_test_writing/e/sbt_top;
import sbt_test_writing/e/sbt_default_constraints;

extend sys {
   setup() is also {
      set_config(run,tick_max,UNDEF);
   }; // setup() is also...

   //instantiate the environment under sys
   sbt_environment: sbt_env_u is instance;
}; // extend sys

extend sbt_env_u {
   //configure the hdl_path to the top level verilog module
   keep hdl_path() == "top";
   
   //connect the clock to the verilog input_clock signal
   event clock_e is only rise('input_clock')@sim;
}; // extend sbt_env_...

extend sbt_reset_agent_u {
   //constrain the hdl signal for reset
   keep sig_reset == "resetn";
}; // extend sbt_rese...

extend sbt_tx_agent_u {
   //create a pointer to the parent environmnent
   env: sbt_env_u;
   keep env == get_enclosing_unit(sbt_env_u);
}; // extent sbt_tx_a...

extend ACTIVE sbt_tx_agent_u {
   
   short_name():string is also {
      if agent_id == 1 then {
         return vt.text_style(DARK_GREEN,append("TX AGENT [",agent_id,"]"));
      };
      if agent_id == 2 then {
         return vt.text_style(DARK_RED,append("TX AGENT [",agent_id,"]"));
      };
      if agent_id == 3 then {
         return vt.text_style(DARK_YELLOW,append("TX AGENT [",agent_id,"]"));
      };
   }; // short_name():st...
   
   //all TX agents should wait for the reset agent to finish 
   //issuing a reset before starting to drive data
   just_before_looping()@clock_e is {
      wait @env.reset_agent.reset_done;      
   }; // just_before_loo...

   //output a nice message to the screen for debugging aid
   just_before_driving()@clock_e is also {
      message(NONE, "Driving SBT packet item: ",current_item);
   }; // just_before_dri...
   
   just_after_driving()@clock_e is also {
      //add the newly received packet to the scoreboard
      env.scoreboards[agent_id-1].add_to_sb(current_item);
   }; // just_after_driv...
}; // extend ACTIVE n...

extend sbt_rx_agent_u {

   //create a pointer to the parent environmnent
   env: sbt_env_u;
   keep env == get_enclosing_unit(sbt_env_u);

   short_name():string is also {
      return vt.text_style(RED,append("RX AGENT [",agent_id,"]"));
   }; // short_name():st...

   just_after_receiving(received_packet: sbt_packet_s)@clock_e is also {
      message(NONE, "Received SBT packet item: ",received_packet);
      
      //add the newly received packet to the scoreboard
      env.scoreboards[agent_id-1].check_from_sb(received_packet);

   }; // just_after_rece...
}; // extend sbt_rx_a...


extend sbt_bfm_u {
   
   //concatenate a string and an internal field to dynamically 
   //control signal naming for both the data and frame pulse signals
   keep sig_data == append("input_data",bfm_id);
   keep sig_fp == append("frame_pulse_in_",bfm_id);

   drive(packet_to_drive: sbt_packet_s)@clock_e is also {
      //emit the packets internal coverage event to collect 
      //functional coverage on the current packets contents
      emit packet_to_drive.collect_coverage_e;
   }; // drive(packet_to...
   
}; // extend sbt_...

extend sbt_monitor_u {
   //concatenate a string and an internal field to dynamically 
   //control signal naming for both the data and frame pulse signals
   keep sig_data == append("output_data_",monitor_id);
   keep sig_fp == append("frame_pulse_out_",monitor_id);
}; // extend sbt_moni...


extend MAIN sbt_sequence_s {
   
   //by default, send between 10 and 20 random sequences
   keep soft count in range [5];
   
   //at the start of the MAIN body(), raise an objection 
   pre_body()@sys.any is also {
      driver.raise_objection(TEST_DONE);
   }; // pre_body()@driv...
   
   //at the end of the MAIN body(), drop the objection 
   post_body()@sys.any is also {
      driver.drop_objection(TEST_DONE);
   }; // post_body()@dri...

}; // extend MAIN nt_...

//collect coverage on the kinds of sequences to send 
//into the DUT

extend sbt_sequence_s {
   event sequence_coverage;
   cover sequence_coverage is {
      item kind;
   }; // cover sequence_...
   body()@driver.clock is also {
      emit sequence_coverage;
   }; // post_body()@sys...
}; // extend sbt_sequ...

'>
