<'
package sbt;

import sbt_types_and_defines;

//This is a simple header struct to be used within the 
//sbt packet struct.  It consists of 4 bytes of data only 
//with an associated kind field.
struct sbt_header_s {
   //The kind field indicates the various kinds of headers
   //that can exist.  Possible values are SBT_HEADER, CUSTOM_HEADER
   kind: sbt_header_kind_t;

   //The data field is a simple list of bytes.  The contents
   //of these bytes are important
   %data[4]: list of byte;

}; // struct sbt_...

'>
