This file will hold all of the interesting sequences for the 
   environment.  Users can modify this file to add any number of 
   new and interesting sequences.

<'
import sbt_sequence;

//create a new simple sequence of GOOD/BAD CRC
extend sbt_sequence_kind_t: [GOOD_BAD_ALTERNATE];

extend GOOD_BAD_ALTERNATE sbt_sequence_s {
 
   //random number of packets to send in 
   //this sequence
   num_packets: uint;
   keep num_packets in range [10..15];

   //extend the body to add functionality
   body()@driver.clock is also {
      for i from 1 to num_packets {
         do packet keeping {
            //send BAD crc on every odd numbered
            //packet in the sequence
            .crc_kind == (even(i)?GOOD:BAD);
         }; // do packet keepi...
      }; // for i from 1 to...
   }; // body()@driver.c...

}; // extend GOOD_BAD...


'>